function s = StabilityEval(z, n)

k=length(n);
S=(1+z./n).^n;

% In this implementation we will use the structure of the recursion,
% namely, the fact that recursion only uses the values in the current and
% previous row. This specific structure allows us to keep all of the
% important values in only a vector (instead of a matrix). 
for l=2:k % Go over columns
    for i=2:k-l+2 % Go over rows
       % The recursion. Write over the preexisting value as we don't need
       % it any longer
        S(i-1)=S(i)+(S(i)-S(i-1))/(n(i+l-2)/n(i-1)-1);
    end
end

s=S(1);

% A straightforward implementation could look something like this
% Stemp=zeros(k,k);
% Stemp(:,1)=((1+z./n).^n)';
% for ll=2:k %for all columns
%     for ii=ll:k %for all lines        
%         Stemp(ii,ll)=Stemp(ii,ll-1)+(Stemp(ii,ll-1)-Stemp(ii-1,ll-1))...
%             /(n(ii)/n(ii-ll+1)-1);
%     end
% end
% Stemp(end,end);


end